-- https://docs.spring.io/spring-authorization-server/docs/current/reference/html/guides/how-to-jpa.html#authorization-schema
CREATE TABLE [authorization] (
    id nvarchar(255) NOT NULL,
    registeredClientId nvarchar(255) NOT NULL,
    principalName nvarchar(255) NOT NULL,
    authorizationGrantType nvarchar(255) NOT NULL,
    attributes nvarchar(4000) DEFAULT NULL,
    [state] nvarchar(500) DEFAULT NULL,
    authorizationCodeValue nvarchar(4000) DEFAULT NULL,
    authorizationCodeIssuedAt datetime DEFAULT NULL,
    authorizationCodeExpiresAt datetime DEFAULT NULL,
    authorizationCodeMetadata nvarchar(2000) DEFAULT NULL,
    accessTokenValue nvarchar(4000) DEFAULT NULL,
    accessTokenIssuedAt datetime DEFAULT NULL,
    accessTokenExpiresAt datetime DEFAULT NULL,
    accessTokenMetadata nvarchar(2000) DEFAULT NULL,
    accessTokenType nvarchar(255) DEFAULT NULL,
    accessTokenScopes nvarchar(1000) DEFAULT NULL,
    refreshTokenValue nvarchar(4000) DEFAULT NULL,
    refreshTokenIssuedAt datetime DEFAULT NULL,
    refreshTokenExpiresAt datetime DEFAULT NULL,
    refreshTokenMetadata nvarchar(2000) DEFAULT NULL,
    oidcIdTokenValue nvarchar(4000) DEFAULT NULL,
    oidcIdTokenIssuedAt datetime DEFAULT NULL,
    oidcIdTokenExpiresAt datetime DEFAULT NULL,
    oidcIdTokenMetadata nvarchar(2000) DEFAULT NULL,
    oidcIdTokenClaims nvarchar(2000) DEFAULT NULL,
    PRIMARY KEY (id)
);
