# spring-auth-server-demo

It's a demo project for spring-auth-server.

This project consist of following three sub-projects.

## spring-auth-server-demo

Auth. server, including identity management.

This project embeds the learnings through the following documents:
- [How-to: Implement core services with JPA](https://docs.spring.io/spring-authorization-server/docs/current/reference/html/guides/how-to-jpa.html)
This article adds the JPA implementations to client/authorization/authorization-consent
- [How-to: Customize the OpenID Connect 1.0 UserInfo response](https://docs.spring.io/spring-authorization-server/docs/current/reference/html/guides/how-to-userinfo.html)
    - [OidcUserInfo](https://docs.spring.io/spring-security/site/docs/current/api/org/springframework/security/oauth2/core/oidc/OidcUserInfo.html)
    - [OidcUserInfo.Builder](https://docs.spring.io/spring-security/site/docs/current/api/org/springframework/security/oauth2/core/oidc/OidcUserInfo.Builder.html)
- [Spring Security: Authentication - JDBC Authentication](https://docs.spring.io/spring-security/reference/servlet/authentication/passwords/jdbc.html#servlet-authentication-jdbc-schema)
- [Spring Authorization Server Tutorial](https://www.appsdeveloperblog.com/spring-authorization-server-tutorial/)
- [Add Roles to JWT Issued by Spring Authorization Server](https://www.appsdeveloperblog.com/add-roles-to-jwt-issued-by-new-spring-authorization-server/)
- [Role-based Access Control in Spring Authorization Server](https://www.appsdeveloperblog.com/role-based-access-control-in-spring-authorization-server/)
- [Spring Security: Authentication with a Database-backed UserDetailsService](https://www.baeldung.com/spring-security-authentication-with-a-database)
- [Password storage](https://docs.spring.io/spring-security/reference/features/authentication/password-storage.html)
- [Spring Security Architecture](https://docs.spring.io/spring-security/reference/servlet/architecture.html)
- [Registration Login example using Spring Boot/Spring Security/JPA/MySql/Thymeleaf](https://www.javaguides.net/2019/08/registration-login-example-using-springboot-spring-data-jpa-hibernate-mysql-thymeleaf.html)
    - [Source repository](https://github.com/RameshMF/registration-login-springboot-security-thymeleaf)
- [Spring Boot + Spring Security + Thymeleaf](https://www.jianshu.com/p/dcf227d53ab5)
    - [Source repository](https://github.com/Smith-Cruise/Spring-Boot-Security-Thymeleaf-Demo)


To be read?
- [Spring Security ACL](https://www.jianshu.com/p/b971b4e6ec16)


Dependencies:
- Java 17;
- Spring Boot 3.0;
    - Spring Boot JPA;
    - Spring Boot Web;
- SQL Server 2019;
- Spring Auth Server;


## spring-resource-server-demo

Resource server.

Related documents:   
- [Spring Boot Resource Server](https://docs.spring.io/spring-security/reference/servlet/oauth2/resource-server/index.html)
- [Resource Server samples](https://github.com/spring-projects/spring-security-samples/tree/main/servlet/spring-boot/java/oauth2/resource-server)


Dependencies:
- Java 17;
- Spring Boot 3.0;
    - Spring Boot JPA;
    - Spring Boot Web;
- SQL Server 2019;
- Resource Server;

## angular-client-demo

An angular client which consume that resources.

Dependencies:
- Angular 14;
- Typescript 4.6.2;

