package com.poc.alvachien.authserverdemo.component;

import org.springframework.context.event.EventListener;
import org.springframework.security.authentication.event.AbstractAuthenticationFailureEvent;
import org.springframework.security.authentication.event.AuthenticationSuccessEvent;
import org.springframework.stereotype.Component;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Component
public class AuthenticationEvents {
	private static final Logger log = LoggerFactory.getLogger(AuthenticationEvents.class);

    // Available events:
    // Refer to : https://docs.spring.io/spring-security/reference/servlet/authentication/events.html

    @EventListener
    public void onSuccess(AuthenticationSuccessEvent success) {
		log.info("Authorizaton success: ", success.toString());
    }

    @EventListener
    public void onFailure(AbstractAuthenticationFailureEvent failures) {
		log.info("Authorizaton failed: ", failures.toString());
    }    
}
