package com.poc.alvachien.authserverdemo.model;

import java.util.ArrayList;
import java.util.List;

import jakarta.persistence.*;

@Entity
@Table(name = "user_account")
public class UserAccount {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(nullable = false, length = 255, columnDefinition = "nvarchar(255)")
    private String username;

    @Column(nullable=false, unique=true, length = 255, columnDefinition = "nvarchar(255)")
    private String email;

    @Column(nullable = false, length = 255, columnDefinition = "nvarchar(255)")
    private String password;

    @Column(nullable = false)
    private boolean active;

    // @OneToMany(mappedBy = "userAccount", fetch = FetchType.EAGER, cascade = CascadeType.REMOVE)
    @ManyToMany(fetch = FetchType.EAGER, cascade=CascadeType.ALL)
    @JoinTable(
            name="users_roles",
            joinColumns={@JoinColumn(name="USER_ID", referencedColumnName="ID")},
            inverseJoinColumns={@JoinColumn(name="ROLE_ID", referencedColumnName="ID")})
    private List<UserRole> roles;

    public UserAccount() {
        this.roles = new ArrayList<>();
    }

    public UserAccount(String name, String email, String pwd, boolean active) {
        this();
        
        this.username = name;
        this.email = email;
        this.password = pwd;
        this.active = active;
    }
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public boolean isActive() {
        return active;
    }

    public void setActive(boolean active) {
        this.active = active;
    }

    public List<UserRole> getRoles() {
        return roles;
    }

    public void setRoles(List<UserRole> userRoles) {
        this.roles = userRoles;
    }
}
