package com.poc.alvachien.authserverdemo.model;

import jakarta.persistence.*;

import java.util.List;

import org.springframework.security.core.GrantedAuthority;

@Entity
@Table(name = "user_role")
public class UserRole implements GrantedAuthority {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(nullable = false, unique = true, length = 50)
    private String name;

    // @ManyToOne(fetch = FetchType.EAGER, optional = false)
    // @JoinColumn(name = "useraccount_id", nullable = false)
    @ManyToMany(mappedBy="roles")
    private List<UserAccount> users;

    public UserRole() {
    }
    public UserRole(String name) {
        this();
        this.name = name;
    }
    
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }


    public Long getId() {
        return id;
    }
    public void setId(Long id) {
        this.id = id;
    }
    public List<UserAccount> getUsers() {
        return users;
    }
    public void setUsers(List<UserAccount> users) {
        this.users = users;
    }

    @Override
    public String getAuthority() {
        return this.getName();
    }    
}
