package com.poc.alvachien.authserverdemo.service;

import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.stereotype.Service;

import org.springframework.security.core.userdetails.UsernameNotFoundException;
import com.poc.alvachien.authserverdemo.model.UserAccount;
import com.poc.alvachien.authserverdemo.model.UserRole;
import com.poc.alvachien.authserverdemo.repository.UserAccountRepository;

import java.util.Collection;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Service
public class MyUserDetailsService implements UserDetailsService {
	private static final Logger log = LoggerFactory.getLogger(MyUserDetailsService.class);
    private final UserAccountRepository userAccountRepository;

    // public MyUserDetailsService(UserAccountRepository userAccountRepository) {
    //     this.userAccountRepository = userAccountRepository;
    // }

    // @Override
    // public UserDetails loadUserByUsername(String username) {
    //     log.info("loadUserByUsername: " + username);
    //     UserAccount userAccount = userAccountRepository.findByUsername(username);
    //     if (userAccount == null) {
    //         log.error("User with username [" + username + "] not found in the system");
    //         try {                
    //             throw new UsernameNotFoundException("User with username [" + username + "] not found in the system");
    //         } catch (UsernameNotFoundException e) {
    //             // TODO Auto-generated catch block
    //             e.printStackTrace();
    //         }
    //     }

    //     return new MyUserDetails(userAccount);
    // }

    public MyUserDetailsService(UserAccountRepository userRepository) {
        this.userAccountRepository = userRepository;
    }

    @Override
    public UserDetails loadUserByUsername(String email) throws UsernameNotFoundException {
        log.info("Entering loadUserByUsername: " + email);
        UserAccount user = userAccountRepository.findByEmail(email);

        if (user != null) {
            return new User(user.getEmail(),
                    user.getPassword(),
                    mapRolesToAuthorities(user.getRoles()));
        }else{
            throw new UsernameNotFoundException("Invalid username or password.");
        }
    }

    private Collection < ? extends GrantedAuthority> mapRolesToAuthorities(Collection <UserRole> roles) {
        Collection < ? extends GrantedAuthority> mapRoles = roles.stream()
                .map(role -> new SimpleGrantedAuthority(role.getName()))
                .collect(Collectors.toList());
        return mapRoles;
    }

}
